/*
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Bitflux GmbH                                      |
// +----------------------------------------------------------------------+
// | Licensed under the Apache License, Version 2.0 (the "License");      |
// | you may not use this file except in compliance with the License.     |
// | You may obtain a copy of the License at                              |
// | http://www.apache.org/licenses/LICENSE-2.0                           |
// | Unless required by applicable law or agreed to in writing, software  |
// | distributed under the License is distributed on an "AS IS" BASIS,    |
// | WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or      |
// | implied. See the License for the specific language governing         |
// | permissions and limitations under the License.                       |
// +----------------------------------------------------------------------+
// | Author: Bitflux GmbH <devel@bitflux.ch>                              |
// +----------------------------------------------------------------------+

*/
var liveSearchReq = false;
var t = null;
var liveSearchLast = "";
var isIE = false;
//var liveSearchURI = "/wiki/TitleSearch";

// on !IE we only have to initialize it once
if (window.XMLHttpRequest) {
  liveSearchReq = new XMLHttpRequest();
}

function liveSearchInit() {
  if (navigator.userAgent.indexOf("Safari") > 0) {
    //	document.getElementById('livesearch').addEventListener("keydown",liveSearchKeyPress,false);
    document.getElementById('livesearch').addEventListener("blur",liveSearchHideDelayed,false);
  } else if (navigator.product == "Gecko") {
    //	document.getElementById('livesearch').addEventListener("keypress",liveSearchKeyPress,false);
    document.getElementById('livesearch').addEventListener("blur",liveSearchHideDelayed,false);
  } else {
    //	document.getElementById('livesearch').attachEvent('onkeydown',liveSearchKeyPress);
    document.getElementById('livesearch').attachEvent("onblur",liveSearchHide,false);
    isIE = true;
  }
  document.getElementById('livesearch').setAttribute("autocomplete","off");
}

function liveSearchHideDelayed() {
  window.setTimeout("liveSearchHide()",400);
}
	
function liveSearchHide() {
  document.getElementById("LSResult").style.display = "none";
  var highlight = document.getElementById("LSHighlight");
  if (highlight) {
    highlight.removeAttribute("id");
  }
}

function liveSearchKeyPress(event) {
  if (event.keyCode == 40 ) { //KEY DOWN
    highlight = document.getElementById("LSHighlight");
    if (!highlight) {
      highlight = document.getElementById("LSResult").firstChild.firstChild;
    } else {
      highlight.removeAttribute("id");
      highlight = highlight.nextSibling;
    }
    if (highlight) {
      highlight.setAttribute("id","LSHighlight");
    } 
    if (!isIE) { event.preventDefault(); }
  } 
  else if (event.keyCode == 38 ) { //KEY UP
    highlight = document.getElementById("LSHighlight");
    if (!highlight) {
      highlight = document.getElementById("LSResult").firstChild.lastChild;
    } 
    else {
      highlight.removeAttribute("id");
      highlight = highlight.previousSibling;
    }
    if (highlight) {
      highlight.setAttribute("id","LSHighlight");
    }
    if (!isIE) { event.preventDefault(); }
  } 
  else if (event.keyCode == 27) { //ESC
    highlight = document.getElementById("LSHighlight");
    if (highlight) {
      highlight.removeAttribute("id");
    }
    document.getElementById("LSResult").style.display = "none";
  } 
}

function liveSearchStart() {
  if (t) {
    window.clearTimeout(t);
  }
  t = window.setTimeout("liveSearchDoSearch()",200);
}

function liveSearchDoSearch() {
  if (liveSearchLast != document.forms.searchform.s.value) {
    if (liveSearchReq && liveSearchReq.readyState < 4) {
      liveSearchReq.abort();
    }
    if ( document.forms.searchform.s.value == "") {
      document.getElementById("LSResult").style.display = "none";
      highlight = document.getElementById("LSHighlight");
      if (highlight) {
	highlight.removeAttribute("id");
      }
      return false;
    }
    if (window.XMLHttpRequest) { 	   // Gecko needs Initialization only once.
      ;
      //liveSearchReq = new XMLHttpRequest();
    } else if (window.ActiveXObject) { // IE/Windows ActiveX
      liveSearchReq = new ActiveXObject("Microsoft.XMLHTTP");
    }
    liveSearchReq.onreadystatechange= liveSearchProcessReqChange;
    liveSearchReq.open("GET", liveSearchURI + "?format=livesearch&paging=none&limit=25&s=" + document.forms.searchform.s.value);
    liveSearchLast = document.forms.searchform.s.value;
    liveSearchReq.send(null);
  }
}

function liveSearchProcessReqChange() {
  if (liveSearchReq.readyState == 4) {
    var  res = document.getElementById("LSResult");
    res.style.display = "block";
    res.innerHTML = liveSearchReq.responseText;
  }
}

function liveSearchSubmit() {
  var highlight = document.getElementById("LSHighlight");
  if (highlight && highlight.firstChild) {
    window.location = highlight.nextSibling.getAttribute("href");
    return false;
  } 
  else {
    return true;
  }
}

function closeResults() {
  document.getElementById("LSResult").style.display = "none";
}
